Austin Group Defect Tracker

Aardvark Mark IV


Viewing Issue Simple Details Jump to Notes ] Issue History ] Print ]
ID Category Severity Type Date Submitted Last Update
0001382 [1003.1(2016/18)/Issue7+TC2] System Interfaces Editorial Clarification Requested 2020-07-24 15:16 2021-01-04 16:09
Reporter tydeman View Status public  
Assigned To
Priority normal Resolution Accepted As Marked  
Status Resolved  
Name Fred J. Tydeman
Organization Tydeman Consulting
User Reference 2018 edition of Issue 7 of Base Specifications
Section XSH: system interfaces: asin()
Page Number 603 (or 651 of 3952)
Line Number 20997
Interp Status ---
Final Accepted Text Note: 0005187
Summary 0001382: Ambiguous statement in asin() and other math functions
Description In looking at asin(), I am confused by the wording in line 20997
"If x is not returned,....."
Which x is it talking about? The one on line 20995 or any x?

Is line 20997 supposed to be a continuation of line 20996?

If yes, but it cannot be because of MX vs MXX shading,
then line 20997 should be changed to
"If a subnormal result is not returned,...."

I believe the same problem exists for many other math functions: at least:
asinh, atan, atanh, expm1, log1p, sin, sinh, tan, tanh
Desired Action Clean up the wording. nextafter() might be a way to show both MX and MXX shading as continuous.
Tags tc3-2008
Attached Files

- Relationships
related to 0000068Closedajosey 1003.1(2008)/Issue 7 tgamma range error overflow text 

-  Notes
(0004899)
geoffclare (manager)
2020-07-24 15:39

This text came from bug 0000068 where it is shown as one paragraph:

    [MX] If x is subnormal, a range error may occur[/MX] [MXX] and x
    should be returned.[/MXX]
    [MX] If x is not returned, asin(), asinf(), and asinl() shall
    return an implementation-defined value no greater in magnitude
    than DBL_MIN, FLT_MIN, and LDBL_MIN, respectively.[/MX]

So the paragraph break is an editorial mistake in applying bug 68. If the paragraph break is changed to a line break, the result would look like the current change from MX to MXX on the previous line, where the shading is continuous.

Changing to "If a subnormal result is not returned,...." won't work because the standard allows a different subnormal (implementation-defined) value to be returned.

The other cases are presumably also all the result of incorrectly applied bug 68 edits.
(0005187)
geoffclare (manager)
2020-12-18 10:16

In the Dec 17th teleconference it was felt that changing the wording so there is only one shading change instead of two would improve the readability, but we ran out of time to check for all of the affected places. I have now looked through the resolution of bug 0000068 and can confirm that the functions listed in the description here are the only ones where an unwanted paragraph break was inserted when the shading changed from one margin code to another.

Proposed changes...

At P603 L20995 (asin), P605 L21059 (asinh), P609 L21166 (atan),
P615 L21324 (atanh), P802 L27261 (expm1), P1276 L42602 (log1p),
P1993 L64163 (sin), P1995 L64237 (sinh), P2112 L67777 (tan) and
P2115 L67865 (tanh), change:
[MX] If x is subnormal, a range error may occur[/MX]
[MXX] and x should be returned.[/MXX]

[MX] If x is not returned, asin(), asinf(), and asinl() shall return an implementation-defined value no greater in magnitude than DBL_MIN, FLT_MIN, and LDBL_MIN, respectively.[/MX]
to (substituting the appropriate function names for asin(), asinf() and asinl()):
[MXX]If x is subnormal, x should be returned.[/MXX]
[MX]If x is subnormal, a range error may occur and, if x is not returned, asin(), asinf(), and asinl() shall return an implementation-defined value no greater in magnitude than DBL_MIN, FLT_MIN, and LDBL_MIN, respectively.[/MX]

Note to the editor: where the shading changes from MXX to MX, use a line break (.br) not a paragraph break (.P).

- Issue History
Date Modified Username Field Change
2020-07-24 15:16 tydeman New Issue
2020-07-24 15:16 tydeman Name => Fred J. Tydeman
2020-07-24 15:16 tydeman Organization => Tydeman Consulting
2020-07-24 15:16 tydeman User Reference => 2018 edition of Issue 7 of Base Specifications
2020-07-24 15:16 tydeman Section => XSH: system interfaces: asin()
2020-07-24 15:16 tydeman Page Number => 603 (or 651 of 3952)
2020-07-24 15:16 tydeman Line Number => 20997
2020-07-24 15:39 geoffclare Note Added: 0004899
2020-12-17 17:12 nick Relationship added related to 0000068
2020-12-18 10:16 geoffclare Note Added: 0005187
2021-01-04 16:09 geoffclare Interp Status => ---
2021-01-04 16:09 geoffclare Final Accepted Text => Note: 0005187
2021-01-04 16:09 geoffclare Status New => Resolved
2021-01-04 16:09 geoffclare Resolution Open => Accepted As Marked
2021-01-04 16:09 geoffclare Tag Attached: tc3-2008


Mantis 1.1.6[^]
Copyright © 2000 - 2008 Mantis Group
Powered by Mantis Bugtracker